#!/usr/bin/bash
# ==========================================================================
#         ____            _                     _____           _
#        / ___| _   _ ___| |_ ___ _ __ ___     |_   _|__   ___ | |___
#        \___ \| | | / __| __/ _ \ '_ ` _ \ _____| |/ _ \ / _ \| / __|
#         ___) | |_| \__ \ ||  __/ | | | | |_____| | (_) | (_) | \__ \
#        |____/ \__, |___/\__\___|_| |_| |_|     |_|\___/ \___/|_|___/
#               |___/
#                             --- System-Tools ---
#                  https://www.nntb.no/~dreibh/system-tools/
# ==========================================================================
#
# Hostname System-Info system-info.d Script
# Copyright (C) 2013-2026 by Thomas Dreibholz
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Contact: thomas.dreibholz@gmail.com

# Bash options:
set -euo pipefail

configdir="$(dirname "$0")"

# Helper function library -> just return when it is not available.
# Exit code 0 will let System-Info continue with the next script!
# shellcheck disable=SC1091
. "${configdir}/banner-helper" || exit 0


# ====== Print banner =======================================================

reset="\x1b[0m"
color1="\x1b[34m"
color2="\x1b[31m"

# ------ Get an UTF-8 icon representing the oeprating system ----------------
if [ "$(print-utf8 -w "💻")" -lt 1 ] ; then
   # The console cannot print multi-byte characters like 😀 or 💻 -> no icon.
   icon=""
else
   case "$(uname)" in
      Linux)   icon="🐧" ;;
      FreeBSD) icon="😈" ;;
      NetBSD)  icon="🚩" ;;
      OpenBSD) icon="🐡" ;;
      SunOS)   icon="☀️" ;;
      Darwin)  icon="🍎" ;;
      GNU)     icon="🦬" ;;
      *)       icon="💻" ;;
   esac
fi

# ------ Print top separator ------------------------------------------------
echo -en "${color1}"
separator " *${icon}" "=" "${icon}*"
echo
center "${color1}-- ${color2}$(gettext "Welcome on the System") ${color1}--"

# ------ Print the hostname FQDN as banner ----------------------------------
(
   maxWidth="$(consolewidth)"   # Console width in characters
   # Try the FQDN hostname as banner first. But it may be too long.
   if ! make-banner "$(hostname -f 2>/dev/null || hostname 2>/dev/null || echo "localhost")" "${maxWidth}" ; then
      # Try the hostname only, if the FQDN is too long.
      if ! make-banner "$(hostname -s 2>/dev/null || echo "localhost")" "${maxWidth}" ; then
         # Something went wrong. Just print the hostname as non-banner string.
         hostname -f 2>/dev/null || hostname 2>/dev/null || echo "localhost"
      fi
   fi
) | while IFS= read -r line ; do
   center "${line}"
done

# ------ Print bottom separator ---------------------------------------------
echo -en "${reset}${color1}"
separator " *${icon}" "=" "${icon}*"
echo -e "${reset}"


# ====== Finish =============================================================

# With exit code 1, no further files in /etc/system-info.d are processed.
# Use exit code 0 to continue processing files.
exit 1   # 1 => No further processing
